import 'dart:core';
import 'dart:io';

String projectAbsolutePath ="";
_write(Map jsonData,String local) async {
  String dataToWrite = '{\n';
  final File file = File('$projectAbsolutePath/assets/app_auto_localize/$local.json');
  await file.create();
  for (String key in jsonData.keys){
    if(validateEntry(key))
      dataToWrite=dataToWrite+key+':'+jsonData[key]+','+'\n';
  }
  dataToWrite=dataToWrite.substring(0,dataToWrite.length-2);
  dataToWrite=dataToWrite+'\n}';
  file.writeAsString(dataToWrite);
}

bool validateEntry(key) => !key.contains("\$")&&!key.contains(":")&&!key.contains("#")&&!key.contains("\\")&&!key.contains("\/")&&key.trim().isNotEmpty&&!key.contains("[")&&!key.contains("^")&&!key.contains("]")&&!key.contains("*")&&key.trim()!=""&&!key.contains("|");


List<String?> jsonData = [];
readContentItem(i,String local) async {
  print(_folders[i].path.toString().substring(_folders[i].path.toString().length-5,_folders[i].path.toString().length)==".dart");

  final file = File(_folders[i].path);
  // Read the file
  final newFileContent = await file.readAsString();
  List<String?> newArray = extractHashtags(newFileContent);
  jsonData = jsonData + newArray;
  print("$i : "+(_folders.length-1).toString());
  if (i == _folders.length - 1) {
    print("strings :");
    print(jsonData);
    Map jsonResult = {};
    for (int i = 0; i < jsonData.length; i++) {
      jsonResult[jsonData[i]] = "\"\"";
    }
    _write(jsonResult, local);
    // transl(jsonData,local);
  }

}

readContent(String local) async {
  getDir();
  for(int i=0;i<_folders.length;i++){
    readContentItem(i,local);
  }
}

List<FileSystemEntity> _folders=[];
getDir() {
  final dir = '$projectAbsolutePath/lib';
  String pdfDirectory = '$dir/';
  final myDir = new Directory(pdfDirectory);
  var dirs = myDir.listSync(recursive: true, followLinks: false);
  for (var element in dirs) {
    if(element.path.toString().substring(element.path.toString().length-5,element.path.toString().length)==".dart"){
      _folders.add(element);
    }
  }
  return _folders;
}

List<String?> extractHashtags(String data) {
  var r1 = r'"([^]*?)"';
  var r2 = r'"([^]*?)"';
  final res = new RegExp('(' + r1 + ")|(" + r2 + ')');
  List<String?> result = res.allMatches(data.trim()).map((data) => data.group(0)).toList();
  return result ;
}

initAutoTranslate({ required String projectPathAbsolute,
  required String fileName}) {
  projectAbsolutePath = projectPathAbsolute;
  readContent(fileName);
}
